# WarpDeplete

WarpDeplete is an M+ Timer for Shadowlands Dungeons.

The goal of this AddOn is to combine the best of all worlds from other timers, concerning features, accuracy, and customizability, as well as wrapping everything in a minimalist and modern design.  
Note that this project is still in beta and bugs in the core functionality will be ironed out in the coming days.

## Features

* Accurate dungeons timers, objective completion times and other stats
* Current pull count prediction
* Alerts for pride spawns after current pull
* Enemy forces count display in tooltips
* Extremely low memory usage (&lt; 200KB on dungeon start)
* Synchronization between group members for timer and objective completion times
* State reconstruction after disconnecting or leaving the dungeon
* Sick design
* Lots of customization options

## How to use

The timer offers sane default out of the box. To customize the display, use the following chat commands:

* `/warp` `/wdp` `/warpdeplete` `/WarpDeplete` - Open the options menu (The different prefixes also work with the other commands)
* `/warp demo` - Toggle the demo mode
* `/warp unlock` `/warp lock` `/warp toggle` - Lock or unlock the frame to move it (Use demo mode for this)

### Why use this timer?

Compared to other timers like GottaGoFast, Angry Keystones or the popular M+ Timer WeakAura (which inspired this AddOn), this timer is more accurate, has lower memory usage and offers more customization. The styling is also more in line with modern minimalist WoW UIs.  
However, all previously named Timers are very good and can definitely be used for the same purpose without any negative impact on game performance or gameplay. In the end, it's just personal preference and the design of the timer that you prefer.

### Why the name?

Depleting keys at warp speed is basically what we did during the development of this AddOn. I hope it will help you do the same.

## Planned Features

* History and best times for dungeon timer and objectives
* Death logs with times and player names
* Even more customization
* Localization
* End of dungeon stats and times sharing after a disconnect

## Credits

This AddOn has benefited a lot from other similar AddOns. Some of the timer features and things like the current pull display were possible to implement way quicker and more easily because there was previous work done the in amazing AddOn [GottaGoFast](https://www.curseforge.com/wow/addons/gottagofast) and the awesome WeakAura [M+ Timer](https://wago.io/M+Timer). You should definitely check these out if there are things about this timer that you don't like, or if you're looking for an alternative.